package com.danitheskunk.skunkworks;

public abstract class BaseGamepad {
	protected final float[] axes;
	protected final boolean[] buttonDown;
	protected final boolean[] buttonPressed;
	protected final int axesCount;
	protected final int buttonCount;

	public BaseGamepad(int axesCount, int buttonCount) {
		this.axesCount = axesCount;
		this.buttonCount = buttonCount;
		axes = new float[axesCount];
		buttonDown = new boolean[buttonCount];
		buttonPressed = new boolean[buttonCount];
	}

	public int getAxesCount() {
		return axesCount;
	}

	public int getButtonCount() {
		return buttonCount;
	}

	public float getAxis(int i) {
		return axes[i];
	}

	public boolean getButtonDown(int i) {
		return buttonDown[i];
	}

	public boolean getButtonPressed(int i) {
		return buttonPressed[i];
	}

	public void setAxis(int i, float value) {
		axes[i] = value;
	}

	public void setButtonDown(int i, boolean value) {
		buttonDown[i] = value;
	}

	public void setButtonPressed(int i, boolean value) {
		buttonPressed[i] = value;
	}

	public void clearButtonPressed() {
		for(int i = 0; i < buttonCount; ++i) {
			buttonPressed[i] = false;
		}
	}

	public abstract void tick();
}
