package com.danitheskunk.skunkworks;

import com.danitheskunk.skunkworks.gfx.Color;
import com.danitheskunk.skunkworks.gfx.IRenderContext;
import com.danitheskunk.skunkworks.gfx.vt.Terminal;
import com.danitheskunk.skunkworks.net.TwitchOauth;
import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;

import java.io.IOException;

public class Test extends BaseGame {
	private Terminal term;

	public Test() {
		super(new Vec2i(40 * 12, 22 * 12), "Skunkworks");

		var fontThin = window.loadFontTileset("fonts\\thin-6x12.png");
		var fontThin2 = window.loadFontTileset("fonts\\thin-12x12.png");
		term = new Terminal(new Vec2i(40, 22), fontThin2, fontThin);

		window.setStretchMode(WindowStretchMode.INTEGER);
		var c1 = Color.GREEN;
		var c2 = new Color(0, 128, 0);

		term.drawHorizontalSingleLine(new Vec2i(0, 0), 20, c2);
		term.drawHalfString(new Vec2i(6, 0), " Upgrades ");

		term.drawHalfString(new Vec2i(0, 1), " a", c1);
		term.drawHalfString(new Vec2i(1, 1), " - [", c2);
		term.drawHalfString(new Vec2i(3, 1), " Upgraded Skeleton", c1);
		term.drawHalfString(new Vec2i(12, 1), " ]", c2);
		term.drawHalfString(new Vec2i(16, 1), "10,000$", c1);

		term.drawHalfString(new Vec2i(0, 2), " b", c1);
		term.drawHalfString(new Vec2i(1, 2), " - [", c2);
		term.drawHalfString(new Vec2i(3, 2), " Upgraded Eyes", c1);
		term.drawHalfString(new Vec2i(10, 2), " ]", c2);
		term.drawHalfString(new Vec2i(16, 2), " 7,000$", c1);

		term.drawHalfString(new Vec2i(0, 3), " c", c1);
		term.drawHalfString(new Vec2i(1, 3), " - [", c2);
		term.drawHalfString(new Vec2i(3, 3), " Upgraded Senses", c1);
		term.drawHalfString(new Vec2i(11, 3), " ]", c2);
		term.drawHalfString(new Vec2i(16, 3), " 6,000$", c1);

		term.drawHalfString(new Vec2i(0, 4), " d", c1);
		term.drawHalfString(new Vec2i(1, 4), " - [", c2);
		term.drawHalfString(new Vec2i(3, 4), " Upgraded Legs", c1);
		term.drawHalfString(new Vec2i(10, 4), " ]", c2);
		term.drawHalfString(new Vec2i(16, 4), " 4,500$", c1);

	}

	public static void main(String[] args) {
		new Test().run();
	}

	@Override
	protected void render(IRenderContext rc) {
		rc.drawTerminal(term);
	}

	@Override
	protected void update(double delta) {
		var mouse = window.getMousePos();
		term.clear(Color.TRANS_BLACK);
		var col = window.isMouseDown(0) ? Color.RED : Color.GREEN;
		term.setBackgroundColor(Vec2i.div(mouse, term.getFullCharSize()), col);
		if(window.isMouseClicked(1)) {
			System.out.println("right click");
		}
	}

	static class TokenHandler implements HttpHandler {
		static String HTML = """
			<html><body><script>
			if(document.location.hash) {
				window.location.href = "http://localhost:42069/?" +
					document.location.hash.slice(1);
			} else {
				window.close();
			}
			</script></body></html>
			""";
		public boolean errored = false;
		public String result = null;

		@Override
		public void handle(HttpExchange exchange) throws IOException {
			var query = exchange.getRequestURI().getQuery();
			exchange.sendResponseHeaders(200, HTML.length());
			var response = exchange.getResponseBody();
			response.write(HTML.getBytes());
			response.close();
			if(query != null) {
				var params = query.split("&");
				for(var param : params) {
					var p = param.split("=");
					if(p[0].equals("access_token")) {
						result = p[1];
						break;
					}
				}
				if(result == null) {
					errored = true;
				}
			}
		}
	}
}
