package com.danitheskunk.skunkworks;

import com.danitheskunk.skunkworks.gfx.Color;
import com.danitheskunk.skunkworks.gfx.IRenderContext;
import com.danitheskunk.skunkworks.gfx.ITexture;
import com.danitheskunk.skunkworks.gfx.Image;
import com.danitheskunk.skunkworks.gfx.threedee.IRenderContext3D;
import com.danitheskunk.skunkworks.gfx.threedee.Mesh;
import com.danitheskunk.skunkworks.gfx.threedee.Model;
import org.lwjgl.assimp.*;

import java.nio.IntBuffer;

@SuppressWarnings("ALL")
public class Test3D extends BaseGame {
	int trans;
	Model model;

	public Test3D() {
		super(new Vec2i(1920, 1080), "Skunkworks 3d test");
		System.out.printf("assimp version: %d.%d.%d\n",
			Assimp.aiGetVersionMajor(),
			Assimp.aiGetVersionMinor(),
			Assimp.aiGetVersionPatch()
		);
		trans = 255;
		var path = "C:\\stream\\models\\Dani.vrm";
		//path = "C:\\stream\\models\\Amber_Arakada_V5_Blendshape.glb";
		//path = "C:\\stream\\models\\Temp Chan 3.glb";
		var bytes = engine.loadBytes(path);
		model = new Model(bytes, window);

		//flags |= Assimp.aiProcess_PreTransformVertices;



	}

	static public void main(String[] args) {
		new Test3D().run();
	}

	@Override
	protected void render(IRenderContext rc) {
		//rc.drawTexture(Vec2i.ZERO, dtex);
	}

	@Override
	protected void render3D(IRenderContext3D rc) {
		rc.renderModel(model);
	}

	@Override
	protected void update(double delta) {
		if(trans > 0) {
			trans -= 1;
		} else {
			trans = 255;
		}
	}
}
