package com.danitheskunk.skunkworks;

import com.danitheskunk.skunkworks.audio.ISample;
import com.danitheskunk.skunkworks.nodes.NodeSprite;
import org.lwjgl.glfw.GLFW;

public class TestNode extends BaseGame {
	private final ISample kick;
	private final NodeSprite sprite;
	float[] axes;

	public TestNode() {
		super(new Vec2i(1280, 720), "Skunkworks");

		kick = loadSample("demoassets/kick.wav");
		sprite = new NodeSprite();
		sprite.setTexture(loadTexture("demoassets/test.png"));
		sprite.setPos(new Vec2f(100, 100));
		rootNode.add(sprite);
		//doThing();

	}

	void doThing() {
		sprite.tweenPos(new Vec2f(800, 400), 120).delay(60).then(() -> {
			System.out.println("yay! got there! now lets go home");
			sprite.tweenPos(new Vec2f(100, 100), 120).then(this::doThing);
			playSample(kick);
		});
	}

	@Override
	protected void update(double delta) {
		sprite.setPos(new Vec2f(640 + 640 * gamepad.getAxis(0), 360 + 360 * gamepad.getAxis(1)));
		if(gamepad.getButtonPressed(0)) {
			playSample(kick);
		}
	}

	public static void main(String[] args) {
		new TestNode().run();
	}
}

