package com.danitheskunk.skunkworks.audio.nodes;

import com.danitheskunk.skunkworks.audio.AudioBuffer;
import com.danitheskunk.skunkworks.audio.AudioEngine;
import com.danitheskunk.skunkworks.audio.Samplei;
import marytts.LocalMaryInterface;
import marytts.exceptions.MaryConfigurationException;
import marytts.exceptions.SynthesisException;
import marytts.util.data.audio.MaryAudioUtils;

import javax.sound.sampled.AudioInputStream;

public class TTS extends Node {
	SamplePlayer samplePlayer;
	LocalMaryInterface mary;

	public TTS(AudioEngine engine) {
		super(engine, 0, 1);
		samplePlayer = new SamplePlayer(engine);
		try {
			mary = new LocalMaryInterface();
		} catch(MaryConfigurationException e) {
			throw new RuntimeException(e);
		}
	}

	public void say(String text) {
		AudioInputStream ais;
		try {
			ais = mary.generateAudio(text);
		} catch(SynthesisException e) {
			throw new RuntimeException(e);
		}
		//todo: use AudioInputStream directly... see why not work atm
		var ds = MaryAudioUtils.getSamplesAsDoubleArray(ais);
		var sample = Samplei.fromMonoDoubleArray(ds);
		samplePlayer.play(sample);
	}

	@Override
	public AudioBuffer getBuffer(int slot) {
		return samplePlayer.getBuffer(slot);
	}
}
