package com.danitheskunk.skunkworks.backends.gl;

public abstract class BasePipeline<TRenderContext, TIRenderContext> {
	protected Program program;
	protected TRenderContext renderContext;

	public BasePipeline(Program program) {
		this.program = program;
	}

	public TIRenderContext getRenderContext() {
		return (TIRenderContext) renderContext;
	}

	public void setRenderContext(TRenderContext renderContext) {
		this.renderContext = renderContext;
	}

	public void use() {
		program.use();
	}

	public abstract void startFrame();
	public abstract void finishFrame();
}
