package com.danitheskunk.skunkworks.backends.gl;

import com.danitheskunk.skunkworks.BaseGamepad;
import org.lwjgl.glfw.GLFW;

public class Gamepad extends BaseGamepad {
	private final int jid;
	public Gamepad(int jid) {
		super(GLFW.glfwGetJoystickAxes(jid).limit(), GLFW.glfwGetJoystickButtons(jid).limit());
		if(!GLFW.glfwJoystickPresent(jid) || !GLFW.glfwJoystickIsGamepad(jid)) {
			throw new RuntimeException("gamepad not found");
		}
		this.jid = jid;
	}

	@Override
	public void tick() {
		var axesBuf = GLFW.glfwGetJoystickAxes(jid);
		var buttonBuf = GLFW.glfwGetJoystickButtons(jid);

		for(int i = 0; i < axesCount; ++i) {
			axes[i] = axesBuf.get(i);
		}

		for(int i = 0; i < buttonCount; ++i) {
			var val = buttonBuf.get() != 0;
			buttonPressed[i] = !buttonDown[i] && val;
			buttonDown[i] = val;
		}
	}
}
