package com.danitheskunk.skunkworks.net;

public class IrcChannel {
	private IrcClient irc;
	private String name;
	private IIrcMessageHandler messageHandler;

	public IrcChannel(IrcClient irc, String name) {
		this.irc = irc;
		this.name = name;
	}

	public void sendMessage(String message) {
		irc.privmsg(name, message);
	}

	public void processMessage(String message, IrcHostmask from) {
		System.out.printf("[%s] <%s> %s\n", name, from.getNick(), message);
		if(messageHandler != null) {
			messageHandler.handleMessage(this, message, from);
		}
	}

	public String getName() {
		return name;
	}

	public void setMessageHandler(IIrcMessageHandler messageHandler) {
		this.messageHandler = messageHandler;
	}
}
