package com.danitheskunk.skunkworks.net;

public class IrcHostmask {
	private final String nick, user, host;

	public IrcHostmask(String nick, String user, String host) {
		this.nick = nick;
		this.user = user;
		this.host = host;
	}

	public static IrcHostmask fromPrefix(String str) {
		String nick;
		String user = "";
		String host = "";

		if(str.contains("@")) {
			var sp = str.split("@");
			host = sp[1];
			str = sp[0];
		}

		if(str.contains("!")) {
			var sp = str.split("!");
			user = sp[1];
			str = sp[0];
		}

		nick = str;

		return new IrcHostmask(nick, user, host);
	}

	public String getNick() {
		return nick;
	}

	public String getUser() {
		return user;
	}

	public String getHost() {
		return host;
	}
}
