package com.danitheskunk.skunkworks.net;

public class Twitch {
	private String clientID;
	private String token;
	private String username;

	public Twitch(String clientID) {
		token = TwitchOauth.getToken(clientID,
			new String[]{"chat:read", "chat:edit"}
		);
		this.clientID = clientID;
		username = getUser();
		System.out.printf("Logged into twitch as \"%s\"\n", username);
	}

	public TwitchChat connectChat() {
		return new TwitchChat(username, token);
	}

	private String getUser() {
		var response = HttpUtils.request("https://api.twitch.tv/helix/users").header("Authorization",
			"Bearer " + token
		).header(
			"Client-Id",
			clientID
		).runJSON();
		var data = (Object[]) response.get("data");
		var user = (java.util.Map) data[0];
		var login = (String) user.get("login");

		return login;
	}
}
