package com.danitheskunk.skunkworks.net;

import com.danitheskunk.skunkworks.Test;
import com.sun.net.httpserver.HttpExchange;
import com.sun.net.httpserver.HttpHandler;
import com.sun.net.httpserver.HttpServer;

import java.awt.*;
import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.URI;
import java.net.URLEncoder;
import java.util.Arrays;

public class TwitchOauth implements HttpHandler {
	static String HTML = """
		<html><body><script>
		if(document.location.hash) {
			window.location.href = "http://localhost:42069/?" +
				document.location.hash.slice(1);
		} else {
			window.close();
		}
		</script></body></html>
		""";
	private boolean errored = false;
	private String result = null;

	public static String getToken(String clientID, String[] scopes) {
		var scopeStr = String.join("+",
			Arrays.stream(scopes).map((String s) -> URLEncoder.encode(s)).toList()
		);
		var uri = URI.create(String.format(
			"https://id.twitch.tv/oauth2/authorize?client_id=%s&redirect_uri=http%%3A%%2F%%2Flocalhost%%3A42069&response_type=token&scope=%s",
			clientID,
			scopeStr
		));


		HttpServer server;

		try {
			server = HttpServer.create(new InetSocketAddress(42069), 0);
		} catch(IOException e) {
			throw new RuntimeException(e);
		}
		var instance = new TwitchOauth();
		server.createContext("/", instance);
		server.setExecutor(null);
		server.start();


		try {
			Desktop.getDesktop().browse(uri);
		} catch(IOException e) {
			throw new RuntimeException(e);
		}

		while(instance.result == null && !instance.errored) {
			try {
				Thread.sleep(1000);
			} catch(InterruptedException e) {
				throw new RuntimeException(e);
			}
			System.out.println("waiting for oauth response");
		}
		if(instance.errored) {
			throw new RuntimeException("oauth error of some sorts...");
		}
		server.stop(0);
		return instance.result;
	}

	@Override
	public void handle(HttpExchange exchange) throws IOException {
		var query = exchange.getRequestURI().getQuery();
		exchange.sendResponseHeaders(200, HTML.length());
		var response = exchange.getResponseBody();
		response.write(HTML.getBytes());
		response.close();
		if(query != null) {
			var params = query.split("&");
			for(var param : params) {
				var p = param.split("=");
				if(p[0].equals("access_token")) {
					result = p[1];
					break;
				}
			}
			if(result == null) {
				errored = true;
			}
		}
	}
}
